// ignore: avoid_web_libraries_in_flutter
import 'dart:js' as js;
import 'package:fis_common/env/env.dart';
import 'package:fis_common/logger/logger.dart';
import 'package:flutter/services.dart';

import 'utils.dart';

class FCrossPlatformUtilsPureWeb extends FCrossPlatformUtils {
  @override
  Future<void> setTitle(String title) async {
    await SystemChrome.setApplicationSwitcherDescription(
      ApplicationSwitcherDescription(
        label: title,
      ),
    );
  }
}

class FCrossPlatformUtilsShellWeb extends FCrossPlatformUtils {
  @override
  Future<void> setTitle(String title) async {
    final api = _getApiHost();
    if (api != null && api.hasProperty("setTitle")) {
      await api.callMethod('setTitle', [title]);
    } else {
      logger.w("FisShellApi.setTitle is undefined.");
    }
  }

  js.JsObject? _getApiHost() {
    if (js.context.hasProperty('FisShellApi')) {
      final api = js.context['FisShellApi'] as js.JsObject;
      return api;
    }
  }
}

FCrossPlatformUtils getUtils() {
  if (FPlatform.isWindows || FPlatform.isMacOS) {
    return FCrossPlatformUtilsShellWeb();
  }
  return FCrossPlatformUtilsPureWeb();
}
