import 'package:flutter/foundation.dart';

import 'env_stub.dart'
    if (dart.library.io) 'env_io.dart'
    if (dart.library.js) 'env_web.dart';

class FisEnv {
  final String platform;
  FisEnv({required this.platform});
}

FisEnv get appEnv => getEnv();

enum FPlatformEnum {
  android,
  iOS,
  web,
  webOnWin,
  webOnMac,
}

class FPlatform {
  static bool get isAndroid => current == FPlatformEnum.android;
  static bool get isIOS => current == FPlatformEnum.iOS;
  static bool get isWindows => current == FPlatformEnum.webOnWin;
  static bool get isMacOS => current == FPlatformEnum.webOnMac;

  /// 是否纯网页端
  static bool get isPureWeb => current == FPlatformEnum.web;

  static FPlatformEnum? _current;

  /// 当前平台
  static FPlatformEnum get current {
    if (_current == null) {
      if (kIsWeb) {
        String name = appEnv.platform;
        if (name.startsWith("Win")) {
          _current = FPlatformEnum.webOnWin;
        } else if (name.startsWith("Mac")) {
          _current = FPlatformEnum.webOnMac;
        } else {
          _current = FPlatformEnum.web;
        }
      } else {
        if (appEnv.platform.toLowerCase().startsWith("android")) {
          _current = FPlatformEnum.android;
        } else {
          _current = FPlatformEnum.iOS;
        }
      }
    }
    return _current!;
  }
}
