import 'package:fis_common/helpers/string.dart';

extension FStringExtensions on String {
  /// 是否中国手机号
  bool get isChineseMobileNumber =>
      RegExp(r'^1(3\d|4[5-9]|5[0-35-9]|6[567]|7[0-8]|8\d|9[0-35-9])\d{8}$')
          .hasMatch(this);

  /// 是否Fis密码 【6-12位字母数字组合】
  bool get isFisPassword =>
      RegExp(r'^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{6,12}$').hasMatch(this);

  /// 格式化字符串
  String format([List<dynamic>? args]) => FStringHelper.formart(this, args);
}

extension FStringNullableExtensions on String? {
  static RegExp exp = RegExp(r'[\S]');

  ///非空
  bool get isNotNullOrEmpty => this != null && this!.isNotEmpty;

  ///为空
  bool get isNullOrEmpty => this == null || this!.length == 0;

  ///是否为空或全为空格
  bool get isNullOrWhiteSpace =>
      this.isNullOrEmpty || (exp.allMatches(this!).length == 0);

  ///是否非空字符串
  bool get isNotNullOrWhiteSpace =>
      this != null && this!.isNotEmpty && (exp.allMatches(this!).length > 0);
}
