import 'response.dart';

enum FHttpErrorType {
  connectTimeout,
  response,
  cancel,
  other,
}

/// DioError describes the error info  when request failed.
class FHttpError implements Exception {
  FHttpError({
    this.response,
    this.type = FHttpErrorType.other,
    this.error,
  });

  FHttpResponse? response;
  FHttpErrorType type;
  dynamic error;
  StackTrace? _stackTrace;

  set stackTrace(StackTrace? stack) => _stackTrace = stack;

  StackTrace? get stackTrace => _stackTrace;

  String get message => (error?.toString() ?? '');

  @override
  String toString() {
    var msg = 'FHttpError [$type]: $message';
    if (_stackTrace != null) {
      msg += '\n$stackTrace';
    }
    return msg;
  }
}
