enum FHttpResponseType {
  /// application/json
  json,

  /// 暂不支持 ...DIO.ResponseBody
  stream,

  /// String encoded with UTF8.
  plain,

  /// List<int>
  bytes
}

class FHttpBaseOptions extends FHttpOptions {
  FHttpBaseOptions({
    String? method,
    int? timeout,
    String baseUrl = '',
    Map<String, dynamic>? queryParameters,
    Map<String, dynamic>? headers,
    FHttpResponseType? responseType = FHttpResponseType.json,
    String? contentType,
  }) : super(
          method: method,
          timeout: timeout,
          headers: headers,
          responseType: responseType,
          contentType: contentType,
        ) {
    this.baseUrl = baseUrl;
    this.queryParameters = queryParameters ?? {};
  }

  late String baseUrl;
  late Map<String, dynamic> queryParameters;
}

class FHttpScopedOptions extends FHttpOptions {
  FHttpScopedOptions({
    String? method,
    int? timeout,
    Map<String, dynamic>? headers,
    FHttpResponseType? responseType = FHttpResponseType.json,
    String? contentType,
  }) : super(
          method: method,
          timeout: timeout,
          headers: headers,
          responseType: responseType,
          contentType: contentType,
        );
}

class FHttpOptions {
  FHttpOptions({
    String? method,
    int? timeout,
    Map<String, dynamic>? headers,
    FHttpResponseType? responseType = FHttpResponseType.json,
    String? contentType,
  }) {
    this.method = method ?? "GET";
    this.timeout = timeout ?? 0;
    this.headers = headers ?? {};
    this.responseType = responseType;
    this.contentType = contentType;
  }

  late String? method;
  late int? timeout;

  late Map<String, dynamic> headers;
  late FHttpResponseType? responseType;
  late String? contentType;
}
