///js 控件抽象类
abstract class BaseJSPlatForm {
  ///设置平台类型
  void setPlatForm(Function(String, String) func);

  ///开始拖拽窗口
  void beginWindowDrag(String windowName);

  ///结束拖拽
  void endWindowDrag(String windowName);

  ///根据名称关闭指定窗口
  void closeWindow(String windowName);

  ///最大化窗口
  void maximizeWindow(String windowName);

  ///最小化窗口
  void minimizeWindow(String windowName);

  ///通知壳子关闭窗口
  void closeSlaveWindow();

  ///导出大文件
  void exportLargeFile(fileJsonData);

  Future<String> getLanguageCode();

  ///压缩大图
  Future<String> compressBigImage(
      String imageData, int width, int height, int quality);

  ///打印pdf
  void printPdf(String base64) {}

  ///用于挂起异步线程
  static Future sleepADuraion() {
    return Future.delayed(const Duration(microseconds: 200));
  }
}
