import 'dart:convert';

import 'package:fis_common/js_plateform/base_js_platform.dart';

// ignore: avoid_web_libraries_in_flutter
import 'dart:js' as js;

///Web端设置js方法
class JSPlatFormImp extends BaseJSPlatForm {
  @override
  void setPlatForm(Function(String, String) func) {
    js.context['invokeJs'] = func;
  }

  @override
  void closeSlaveWindow() {
    js.context.callMethod('closeSlaveWindow');
  }

  @override
  Future<String> getLanguageCode() async {
    var result = '';
    var done = false;
    js.context.callMethod('getLanguageCode', [
      (v) {
        result = v;
        done = true;
      }
    ]);
    while (!done) {
      await Future.delayed(Duration(milliseconds: 100));
    }
    return result;
  }

  @override
  void exportLargeFile(fileJsonData) {
    js.context.callMethod('exportLargeFile', [fileJsonData]);
  }

  @override
  Future<String> compressBigImage(
      String imageData, int width, int height, int quality) async {
    var jsonPara = {
      "quality": quality,
      "width": width,
      "height": height,
    };
    var finalData = "";
    var done = false;
    js.context.callMethod('canvasDataURL', [
      imageData,
      jsonEncode(jsonPara),
      (base64data) {
        finalData = base64data.toString().split(",")[1];
        done = true;
      }
    ]);

    while (!done) {
      await BaseJSPlatForm.sleepADuraion();
    }
    return finalData;
  }

  @override
  void beginWindowDrag(String windowName) {
    js.context.callMethod('beginWindowDrag', [windowName]);
  }

  @override
  void endWindowDrag(String windowName) {
    js.context.callMethod('endWindowDrag', [windowName]);
  }

  @override
  void closeWindow(String windowName) {
    js.context.callMethod('closeWindow', [windowName]);
  }

  @override
  void maximizeWindow(String windowName) {
    js.context.callMethod('maximizeWindow', [windowName]);
  }

  @override
  void minimizeWindow(String windowName) {
    js.context.callMethod('minimizeWindow', [windowName]);
  }

  @override
  void printPdf(String base64) {
    js.context.callMethod('printPdfByBase64', [base64]);
  }
}
