import 'dart:async';
import 'package:universal_html/js.dart';

///Js工具类
class JsUtils {
  JsUtils._();

  /// 执行异步js方法
  static Future invokeJsPromise(
    JsObject? obj,
    String method, [
    List? args,
  ]) {
    final ctx = obj ?? context;
    final promise = ctx.callMethod(method, args) as JsObject;
    final completer = Completer();
    promise.callMethod('then', [
      (args) {
        completer.complete(args);
      },
    ]);
    promise.callMethod('catch', [
      (reason) {
        completer.completeError(Exception(reason));
      },
    ]);
    return completer.future;
  }
}

extension JsObjectEx on JsObject {
  /// 执行异步js方法
  ///
  /// [method] 方法名
  ///
  /// [args] 参数集
  Future invokeJsPromise(
    String method, [
    List? args,
  ]) {
    return JsUtils.invokeJsPromise(this, method, args);
  }
}
