import 'package:universal_html/html.dart' as html;

class WebUtils {
  static String? _websiteRootPath;

  /// 当前网站根目录
  static String get rootPath {
    _websiteRootPath ??= _findRootPath()!;
    return _websiteRootPath!;
  }

  static String? _findRootPath() {
    final nodes = html.document.getElementsByTagName("script");
    const tag = "main.dart.js";
    for (final node in nodes) {
      final script = node as html.ScriptElement;
      final index = script.src.indexOf(tag);
      if (index > -1) {
        return script.src.substring(0, index);
      }
    }
    return html.window.location.origin;
  }
}
